/**
 * vbgtH[̃V{`Ȃ
 *
 *	jIȌo܂ɂAV{ɓꊴȂ
 *	̌nɂ͈̂dł
 *	ÂȂ #ifdef ł͂ȂAV{1/0Ȃǂ̒lK^
 *	#if AX_WIN_MSC_ ̂悤ɔ肷悤ɉ߂悢
 *	΁A~XXyɑ΂ăRpCG[҂ł
 *
 * $Id: AHPlatformDefs.h 5224 2023-09-22 11:34:00Z morinaga $
 * Copyright (C) 1999-2009, Antenna House, Inc.  All Rights Reserved.
 */

/*
	Pre-defined C/C++ Compiler Macros
	https://sourceforge.net/p/predef/wiki/Home/

	LanguageStandards
	Name	Macro						Standards
	C89		__STDC__					ANSIX3.159-1989
	C90		__STDC__					ISO/IEC9899:1990
	C94		__STDC_VERSION__=199409L	ISO/IEC9899-1:1994
	C99		__STDC_VERSION__=199901L	ISO/IEC9899:1999
	C11		__STDC_VERSION__=201112L	ISO/IEC9899:2011
	C++98	__cplusplus=199711L			ISO/IEC14882:1998
	C++11	__cplusplus=201103L			ISO/IEC14882:2011
	C++14	__cplusplus=201402L			ISO/IEC14882:2014
	C++17	__cplusplus=201703L			ISO/IEC14882:2017
	C++/CLI	__cplusplus_cli=200406L		ECMA-372
	DSP-C								ISO/IECJTC1/SC22WG14/N854
	EC++	__embedded_cplusplus		EmbeddedC++
*/


#ifndef AH_PLATFORMDEFS_H_
#define AH_PLATFORMDEFS_H_
#if !defined RC_INVOKED		// Windows\[XRpCŖɂ

	#if !defined AH_NO_AHVERSION
	// (x64) \Lp~ĂAo[W䂷邽߂ AHVersion.h ǂ
	// AHVersion.h݂ȂƂ AH_NO_AHVERSION `邱
	  #include <AHVersion/AHVersion.h>
	  #if defined AHCOMMONVER && AHCOMMONVER>=204
		#define CCCTRL_AH_NOTUSE_x64	// Mantis24273
	  #endif
	#endif// !defined AH_NO_AHVERSION

	#undef AH_OS_BITS	// 32 or 64 (OSł͂ȂăRpC̃rbg)
	#undef AH_RES_PLATFORM	// vbgtH[O

	#undef AH_WIN_MSC_
		#undef AH_WIN32_MSC_
		#undef AH_WIN64_MSC_
	#undef AH_ANDROID_
		#undef AH_ANDROID64_ARM_GCC_
		#undef AH_ANDROID_ARM_GCC_
		#undef AH_ANDROID_X86_GCC_
	#undef AH_LINUX_
		#undef AH_LINUX_GCC_
		#undef AH_LINUX64_GCC_
		#undef AH_AMAZON_LINUX2_GRAVITON2_GCC_
	#undef AH_SOLARIS_
		#undef AH_SOLARIS_SPARC_CC_
		#undef AH_SOLARIS_X86_CC_
		#undef AH_SOLARIS64_SPARC_CC_
		#undef AH_SOLARIS64_X86_CC_
	#undef AH_IBM_AIX_
		#undef AH_IBM_AIX_GCC_	// ͎gȂ
		#undef AH_IBM_AIX_VAC_	// g
		#undef AH_IBM_AIX64_VAC_
	#undef AH_MACOSX_
		#undef AH_MACOSX_GCC_
		#undef AH_MACOSX_X86_GCC_
		#undef AH_MACOSX_X86_64_CLANG_
		#undef AH_MACOSX_M1_CLANG_
	#undef AH_HPUX_
		#undef AH_HPUX_IA_
		#undef AH_HPUX_PA_
		#undef AH_HPUX_IA64_	//  32bitȂ̂ŗv
		#undef AH_HPUX_11V1_
		#undef AH_HPUX64_IA64_
		#undef AH_HPUX64_11V1_
	#undef AH_IOS_
		#undef AH_IOS64_ARM_GCC_
		#undef AH_IOS_ARM_GCC_
	#undef AH_MINGW64
		#undef AH_MINGW64_X86_GCC_

	#undef AH_HAVE_16BIT_WCHAR_T	// sizeof(wchar_t) == 2
	#undef AH_HAVE_WCHAR_H			// wchar.h L
	#undef AH_HAVE_WCTYPE_H			// wctype.h L
	#undef AH_HAVE_STDINT_H			// stdint.h L
	#undef AH_HAVE_BIG_ENDIAN		// Big Endian
	#undef AH_HAVE_UUIDAPI			// UUID֘AAPI
	#undef AH_HAVE_HASH_SETMAP		// stdex::hase_set/map
	#undef AH_HAVE_UNORDERED_SETMAP	// std::unordered_set/map
	#undef AH_CASESENSE_FILENAME	// t@Cɑ啶ʂ
	#undef AH_NEED_SECURE_API		// strcpy_s() ̃ZLAAPIKv
	#undef AH_HAVE_VLA				// ϒz
	#undef AH_HAVE_STDRAND			// std::random L
	#undef AH_HAVE_UNIQUE_PTR		// unique_ptr g
		// auto_ptrC++11Ŕp~Bunique_ptrg
		#if defined __cplusplus && __cplusplus >= 201103L
		#define AH_HAVE_UNIQUE_PTR
		#define AH_HAVE_STDRAND
		#endif
	#undef AH_HAVE_CHAR16_T
	#undef AH_OVER_CPP11 // C++11ȏ̋@\gBVS2015  __cplusplus mȒlłȂߗp
	// AH_SIZEOF_*  sizeof g킸ɐl`
	#undef AH_SIZEOF_SHORT
	#undef AH_SIZEOF_INT
	#undef AH_SIZEOF_LONG
	#undef AH_SIZEOF_PTR
	#undef AH_SIZEOF_LLONG
	#undef AH_SIZEOF_SIZET

	#undef AH_INT16
	#undef AH_INT32
	#undef AH_INT64
	#undef AH_UINT16
	#undef AH_UINT32
	#undef AH_UINT64
	#undef AH_LLONG

#if 	__cplusplus>=201103L
	#define AH_OVER_CPP11
#endif

#if defined _MSC_VER
	// VisualStudio 6.0      : VC6.0  : 1200
	// VisualStudio.NET 2002 : VC7.0  : 1300
	// VisualStudio.NET 2003 : VC7.1  : 1310
	// VisualStudio 2005     : VC8.0  : 1400
	// VisualStudio 2008     : VC9.0  : 1500
	// VisualStudio 2010     : VC10.0 : 1600
	// VisualStudio 2012     : VC11.0 : 1700
	// VisualStudio 2013     : VC12.0 : 1800
	// VisualStudio 2015     : VC14.0 : 1900
	// VisualStudio 2017     : VC14.1 : 1910
	// VisualStudio 2019     : VC14.2 : 1920
	#define AH_WIN_MSC_
	#if defined AHCOMMONVER && AHCOMMONVER>=205
		#define AH_WIN_MAX_PATH_LONG 32767
	#endif
	// Windows MSC]
	#if defined _WIN64
		#define AH_WIN64_MSC_
		#define AH_OS_BITS	64
		#ifdef CCCTRL_AH_NOTUSE_x64
		#define AH_RES_PLATFORM "Windows"
		#else
		#define AH_RES_PLATFORM "Windows (x64)"
		#endif
		/*	amd64/cl
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(__int64) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 8
			sizeof(size_t) = 8
			sizeof(wchar_t) = 2
			sizeof(void*) = 8
			sizeof(std::streamoff) = 8
		*/
		#define AH_HAVE_16BIT_WCHAR_T
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_UUIDAPI
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	__int64
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned __int64
		#define AH_LLONG	__int64
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_LLONG 8
		#define AH_SIZEOF_SIZET 8
		#define AH_SIZEOF_PTR	8
	#elif defined _WIN32
		#define AH_WIN32_MSC_
		#define AH_OS_BITS	32
		#ifdef CCCTRL_AH_NOTUSE_x64
		#define AH_RES_PLATFORM "Windows (x86)"
		#else
		#define AH_RES_PLATFORM "Windows"
		#endif
		/*	cl
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(__int64) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 8
			sizeof(size_t) = 4
			sizeof(wchar_t) = 2
			sizeof(void*) = 4
			sizeof(std::streamoff) = 8
		*/
		#define AH_HAVE_16BIT_WCHAR_T
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_UUIDAPI
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	__int64
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned __int64
		#define AH_LLONG	__int64
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
		#define AH_SIZEOF_SIZET 4
	#else
		#error "Unknown Windows platform!"
	#endif
	#if _MSC_VER >= 1400
		#define AH_NEED_SECURE_API
	#endif
	#if _MSC_VER >= 1600 && _MSC_VER < 1900
		#define AH_HAVE_HASH_SETMAP
	#endif
	#if _MSC_VER >= 1900
		#define AH_OVER_CPP11
		#define AH_HAVE_UNORDERED_SETMAP
	#endif
	#if _MSC_VER >= 1600
		#define AH_HAVE_STDRAND
		#define AH_HAVE_STDINT_H
	#endif

	#if _MSC_VER >= 1910
		#define AH_HAVE_CHAR16_T
	#endif

	#if defined __INTEL_COMPILER
		//Visual StudioɃCeRpCgݍŎgpꍇA
		//_MSC_VER̒`͗LȂ܂܁A__INTEL_COMPILER`B
		#define AH_WIN_MSC_INTEL_
		#if defined _WIN64
			#define AH_WIN64_MSC_INTEL_
		#elif defined _WIN32
			#define AH_WIN32_MSC_INTEL_
		#endif
		//	#undef  AH_HAVE_HASH_SETMAP			// ͎gȂ悤ɂ邩?
		#undef AH_RES_PLATFORM
		#if defined _WIN64
			#ifdef CCCTRL_AH_NOTUSE_x64
			#define AH_RES_PLATFORM "Windows (intl)"
			#else
			#define AH_RES_PLATFORM "Windows (x64:intl)"
			#endif
		#elif defined _WIN32
			#ifdef CCCTRL_AH_NOTUSE_x64
			#define AH_RES_PLATFORM "Windows (x86:intl)"
			#else
			#define AH_RES_PLATFORM "Windows (intl)"
			#endif
		#endif
	#endif

#elif defined __GNUC__ && defined __linux__ && defined __ANDROID__
	#define AH_ANDROID_
	#define AH_HAVE_UNIQUE_PTR
	// Android
	// 64bit̒̕`́A܂Ȃ̂ŐɂbԁB
	// 2013/11/21 by show
	// ʏLinux̑Oɔ肷邱ƁB
	// 2013/11/22 by show
	#if defined __ARM_EABI__ && defined __LP64__
		#define AH_ANDROID64_ARM_GCC_
		#define AH_OS_BITS	64
		#define AH_RES_PLATFORM "Android ARM 64bit"
		#define AH_HAVE_STDINT_H
		//#define AH_HAVE_WCHAR_H	// Android́Awchar_t͔񐄏
		//#define AH_HAVE_WCTYPE_H	// Android́Awchar_t͔񐄏
		//#define AH_HAVE_UUIDAPI	// Android́AUUIDAPIȂ
		#define AH_CASESENSE_FILENAME
		/*	g++
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 8
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = 8
			sizeof(wchar_t) = 4
			sizeof(void*) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	8
		#define AH_SIZEOF_PTR	8
		#define AH_SIZEOF_LLONG 8
		#define AH_SIZEOF_SIZET 8
	#elif defined __arm__
		#define AH_ANDROID_ARM_GCC_
		#define AH_OS_BITS	32
		#define AH_RES_PLATFORM "Android ARM 32bit"
		#define AH_HAVE_STDINT_H
		//#define AH_HAVE_WCHAR_H	// Android́Awchar_t͔񐄏
		//#define AH_HAVE_WCTYPE_H	// Android́Awchar_t͔񐄏
		//#define AH_HAVE_UUIDAPI	// Android́AUUIDAPIȂ
		#define AH_CASESENSE_FILENAME
		/*	g++
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 8
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 4
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	#elif defined __i386__
		#define AH_ANDROID_X86_GCC_
		#define AH_OS_BITS	32
		#define AH_RES_PLATFORM "Android X86 32bit"
		#define AH_HAVE_STDINT_H
		//#define AH_HAVE_WCHAR_H	// Android́Awchar_t͔񐄏
		//#define AH_HAVE_WCTYPE_H	// Android́Awchar_t͔񐄏
		//#define AH_HAVE_UUIDAPI	// Android́AUUIDAPIȂ
		#define AH_CASESENSE_FILENAME
		/*	g++
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 8
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 4
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	#endif

#elif defined __GNUC__ && defined __linux__
	#define AH_LINUX_
	// Linux
	#if defined __cplusplus && __cplusplus>=201103
			#define AH_HAVE_UNORDERED_SETMAP
	#endif
	#if defined __LP64__

		#define AH_OS_BITS	64
		#if defined __aarch64__
			#define AH_AMAZON_LINUX2_GRAVITON2_GCC_
			#define AH_RES_PLATFORM "Amazon Linux 2 Graviton2"
		#else
			#define AH_LINUX64_GCC_
			#ifdef CCCTRL_AH_NOTUSE_x64
			#define AH_RES_PLATFORM "Linux"
			#else
			#define AH_RES_PLATFORM "Linux64"
			#endif
		#endif

		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_UUIDAPI
		#define AH_HAVE_VLA
		#define AH_CASESENSE_FILENAME
		/*	g++
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 8
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = 8
			sizeof(wchar_t) = 4
			sizeof(void*) = 8
			sizeof(std::streamoff) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	8
		#define AH_SIZEOF_PTR	8
		#define AH_SIZEOF_LLONG 8
		#define AH_SIZEOF_SIZET 8
	#else
		#define AH_LINUX_GCC_
		#define AH_OS_BITS	32
		#ifdef CCCTRL_AH_NOTUSE_x64
		#define AH_RES_PLATFORM "Linux32"
		#else
		#define AH_RES_PLATFORM "Linux"
		#endif
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_UUIDAPI
		#define AH_HAVE_VLA
		#define AH_CASESENSE_FILENAME
		/*	g++
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 12
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 4
			sizeof(std::streamoff) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	#endif

#elif defined __sun && defined __unix
	#define AH_SOLARIS_ __SUNPRO_CC
	// _LP64g߂ɂ sys/types.hKvB2007/05/08 by show
	#include <sys/types.h>
	#if defined __sparc
		// Sun Solaris
	  #if defined _LP64
		#define AH_SOLARIS64_SPARC_CC_
		#define AH_OS_BITS	64
		#define AH_RES_PLATFORM "Solaris (SPARC64)"
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_BIG_ENDIAN
		#if __SUNPRO_CC>=0x580
		#define AH_HAVE_UUIDAPI		// Solaris8 ɂ͊܂܂ĂȂ
		//#define AH_HAVE_STDINT_H
		#endif
		#define AH_CASESENSE_FILENAME
		/*	/opt/SUNWspro/bin/CC -xarch=v9 or -xarch=generic64
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 8
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	8
		#define AH_SIZEOF_PTR	8
		#define AH_SIZEOF_LLONG 8
	  #else
		// OS̃o[W̔@킩Ȃ̂ŃRpC̃o[WŔ肷
		// CRpC(cc)ł͒`Ȃ̂Œ
		// __SUNPRO_CC = 0x540	Solaris8
		// __SUNPRO_CC = 0x580	Solaris10
		#define AH_SOLARIS_SPARC_CC_
		#define AH_OS_BITS	32
		#define AH_RES_PLATFORM "Solaris (SPARC)"
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_BIG_ENDIAN
		#if __SUNPRO_CC>=0x580
		#define AH_HAVE_UUIDAPI		// Solaris8 ɂ͊܂܂ĂȂ
		//#define AH_HAVE_STDINT_H
		#endif
		#define AH_CASESENSE_FILENAME
		/*	/opt/SUNWspro/bin/CC
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 4
			sizeof(std::streamoff) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	  #endif

	#elif defined __i386 || defined __amd64
		// X86 Solaris10
	  #if defined _LP64
		#define AH_SOLARIS64_X86_CC_
		#define AH_OS_BITS	64
		#define AH_RES_PLATFORM "Solaris (X86 64bit)"
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#if __SUNPRO_CC>=0x580
		#define AH_HAVE_UUIDAPI		// Solaris8 ɂ͊܂܂ĂȂ
		//#define AH_HAVE_STDINT_H
		#endif
		//#define AH_HAVE_STDINT_H
		#define AH_CASESENSE_FILENAME
		/*	/opt/SUNWspro/bin/CC -xarch=amd64
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 8
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	8
		#define AH_SIZEOF_PTR	8
		#define AH_SIZEOF_LLONG 8
	  #else
		// __SUNPRO_CC = 0x580
		#define AH_SOLARIS_X86_CC_
		#define AH_OS_BITS	32
		#define AH_RES_PLATFORM "Solaris (X86)"
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#if __SUNPRO_CC>=0x580
		#define AH_HAVE_UUIDAPI		// Solaris8 ɂ͊܂܂ĂȂ
		//#define AH_HAVE_STDINT_H
		#endif
		//#define AH_HAVE_STDINT_H
		#define AH_CASESENSE_FILENAME
		/*	/opt/SUNWspro/bin/CC
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 12
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 4
			sizeof(std::streamoff) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	  #endif

	#else
		#error "Unknown Solaris platform!"
	#endif

#elif defined _AIX
	#define AH_IBM_AIX_
	#if defined __GNUC__
		// IBM AIX (32bit)
		#define AH_IBM_AIX_GCC_
		#define AH_OS_BITS	32
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_BIG_ENDIAN
		#define AH_CASESENSE_FILENAME
		#error "Please use VAC on AIX"
	#else
	  #ifdef _LP64
		#define AH_IBM_AIX64_VAC_
		#define AH_OS_BITS	64
		#define AH_RES_PLATFORM "AIX (64bit)"
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_BIG_ENDIAN
		//#define AH_HAVE_UUIDAPI
		#define AH_CASESENSE_FILENAME
		/*	/usr/vacpp/bin/xlC_r -q64
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 8
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 8
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	8
		#define AH_SIZEOF_PTR	8
		#define AH_SIZEOF_LLONG 8
	  #else
		#define AH_IBM_AIX_VAC_
		#define AH_OS_BITS	32
		#define AH_RES_PLATFORM "AIX (32bit)"
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_BIG_ENDIAN
		//#define AH_HAVE_UUIDAPI
		#define AH_CASESENSE_FILENAME
		/*	/usr/vacpp/bin/xlC_r
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 8
			sizeof(size_t) = ?
			sizeof(wchar_t) = 2
			sizeof(void*) = 4
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	  #endif

	#endif

#elif defined __hpux
	#define AH_HPUX_
	#if defined __ia64
	  #define AH_HPUX_IA_
	  #ifdef __LP64__
		#define AH_HPUX64_IA64_
		#define AH_OS_BITS	64
//		#define AH_RES_PLATFORM "HP-UX B.11.23 (64)"
		#define AH_RES_PLATFORM "HP-UX IA-64"
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_BIG_ENDIAN
		//#define AH_HAVE_UUIDAPI
		#define AH_CASESENSE_FILENAME
		/*	aCC +DD64
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 8
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	8
		#define AH_SIZEOF_PTR	8
		#define AH_SIZEOF_LLONG 8
	  #else
		#define AH_HPUX_IA64_
		#define AH_OS_BITS	32
//		#define AH_RES_PLATFORM "HP-UX B.11.23"
		#define AH_RES_PLATFORM "HP-UX IA-64 (32bit)"
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_BIG_ENDIAN
		#define AH_CASESENSE_FILENAME
		/*	aCC
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 4
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	  #endif

	#elif defined __hppa
	  #define AH_HPUX_PA_
	  #ifdef __LP64__
		#define AH_HPUX64_11V1_
		#define AH_OS_BITS	64
//		#define AH_RES_PLATFORM "HP-UX B.11.11 (64)"
		#define AH_RES_PLATFORM "HP-UX PA-RISC"
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_BIG_ENDIAN
		//#define AH_HAVE_UUIDAPI
		#define AH_CASESENSE_FILENAME
		/*	aCC +DD64
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 8
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	8
		#define AH_SIZEOF_PTR	8
		#define AH_SIZEOF_LLONG 8
	  #else
		#define AH_HPUX_11V1_
		#define AH_OS_BITS	32
//		#define AH_RES_PLATFORM "HP-UX B.11.11"
		#define AH_RES_PLATFORM "HP-UX PA-RISC (32bit)"
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_BIG_ENDIAN
		//#define AH_HAVE_UUIDAPI
		#define AH_CASESENSE_FILENAME
		/*	aCC
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 4
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	  #endif

	#else
		#error "Unknown HP-UX platform!"
	#endif

#elif defined AH_BUILD_IOS && defined __APPLE_CC__ && defined __APPLE__ && (defined __arm || defined __arm64 || defined __i386 || defined __amd64)
	#define AH_IOS_
	// iOS(iPhone, iPad)
	// 64bit̒̕`́A܂Ȃ̂ŐɂbԁB
	// Xcode 5́A{gcc, g++݂͑AǵACLANG/LLVMRpCɒuĂBAgcc, g++̖OŁACLANG/LLVMRpCg悤ɂȂĂB
	// 2013/11/21 by show
	// ʏMacOS̑Oɔ肷邱ƁB
	// 2013/11/22 by show
	// __GNUC__ł͂ȂA__APPLE_CC__Ŕ肷悤ɂB
	// __ARM_ARCHł͂ȂA__arm__arm64Ŕ肷悤ɂB
	// 2014/01/16 by show
	// V~[^̂߂ɁA__i386__amd64ǉB
	// 2014/01/17 by show
	// V~[^̃rhAʏMacOS̃rhƏdȂĂ܂߁A
	// AH_BUILD_IOS`ȂƁAiOS̃rhɂȂȂ悤ɂB
	// 2014/01/21 by show
	#if defined __arm64
		#define AH_IOS_ARM64_APPLE_CC_
		#define AH_OS_BITS	64
		#define AH_RES_PLATFORM "iOS ARM 64bit"
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		//#define AH_HAVE_UUIDAPI	// iOŚAUUIDAPIȂ
		#define AH_CASESENSE_FILENAME
		/*	g++
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 8
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = 8
			sizeof(wchar_t) = 4
			sizeof(void*) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	8
		#define AH_SIZEOF_PTR	8
		#define AH_SIZEOF_LLONG 8
		#define AH_SIZEOF_SIZET 8
	#elif defined __arm
		#define AH_IOS_ARM_APPLE_CC_
		#define AH_OS_BITS	32
		#define AH_RES_PLATFORM "iOS ARM 32bit"
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		//#define AH_HAVE_UUIDAPI	// iOŚAUUIDAPIȂ
		#define AH_CASESENSE_FILENAME
		/*	g++
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 8
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 4
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	#elif defined __amd64
		#define AH_IOS_SIM64_APPLE_CC_
		#define AH_OS_BITS	64
		#define AH_RES_PLATFORM "iOS Simulator 64bit"
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		//#define AH_HAVE_UUIDAPI	// iOŚAUUIDAPIȂ
		#define AH_CASESENSE_FILENAME
		/*	g++
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 8
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = 8
			sizeof(wchar_t) = 4
			sizeof(void*) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	8
		#define AH_SIZEOF_PTR	8
		#define AH_SIZEOF_LLONG 8
		#define AH_SIZEOF_SIZET 8
	#elif defined __i386
		#define AH_IOS_SIM_APPLE_CC_
		#define AH_OS_BITS	32
		#define AH_RES_PLATFORM "iOS Simulator 32bit"
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		//#define AH_HAVE_UUIDAPI	// iOŚAUUIDAPIȂ
		#define AH_CASESENSE_FILENAME
		/*	g++
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 8
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 4
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	#else
		#error "Unknown iOS platform!"
	#endif

#elif (defined __GNUC__ || defined __clang__ ) && defined __APPLE__
	#define AH_MACOSX_
	// Mac OS X (Core Darwin)
	// :
	// https://developer.apple.com/jp/devcenter/ios/library/documentation/cross_development.pdf
	// 
	//	vvZbTLqqgRpC
	//	#ifdef __MAC_OS_X_VERSION_MAX_ALLOWED
	//		Ώۂ Mac OS X łiiOS ł͂ȂjꍇɌRpCR[h
	// Ƃ邪A20140120݁A192.168.16.162̊ł
	//	#include <AvailabilityMacros.h>
	// Ă`Ȃ
	#if (defined __ppc__ && defined __GNUC__ )
		#define AH_MACOSX_GCC_
		#define AH_OS_BITS	32
	//	#define AH_RES_PLATFORM "MacOSX (ppc)"
		#define AH_RES_PLATFORM "macOS (ppc)"
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_BIG_ENDIAN
		//#define AH_HAVE_UUIDAPI
		//#define AH_CASESENSE_FILENAME
		/*
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 8
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 4
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	#elif (defined __i386__ && defined __GNUC__)
		#define AH_MACOSX_X86_GCC_
		#define AH_OS_BITS	32
	//	#define AH_RES_PLATFORM "MacOSX (x86)"
		#define AH_RES_PLATFORM "macOS (x86)"
		#define AH_HAVE_STDINT_H
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		//#define AH_HAVE_BIG_ENDIAN
		//#define AH_HAVE_UUIDAPI
		//#define AH_CASESENSE_FILENAME
		/* i686-apple-darwin9-g++-4.0.1
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = ?
			sizeof(wchar_t) = 4
			sizeof(void*) = 4
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	4
		#define AH_SIZEOF_LLONG 8
	#elif ((defined __x86_64__ ||  defined __arm64) && defined __clang__ )
		#if defined __arm64
			#define AH_MACOSX_M1_CLANG_
			#define AH_RES_PLATFORM "macOS (M1)" //M1Ή
		#else
			#define AH_MACOSX_X86_64_CLANG_
			#ifdef CCCTRL_AH_NOTUSE_x64
			#define AH_RES_PLATFORM "macOS"
			#else
			#define AH_RES_PLATFORM "macOS (x86_64)"
			#endif
		#endif

		#define AH_OS_BITS	64

//		#define AH_HAVE_16BIT_WCHAR_T
		#define AH_HAVE_WCHAR_H
		#define AH_HAVE_WCTYPE_H
		#define AH_HAVE_STDINT_H
//		#define AH_HAVE_BIG_ENDIAN
		#define AH_HAVE_UUIDAPI
//		#defife AH_HAVE_HASH_SETMAP
		#define AH_HAVE_UNORDERED_SETMAP
//		#define AH_CASESENSE_FILENAME
//		#define AH_NEED_SECURE_API
		#define AH_HAVE_VLA
		/* x86-64-apple-darwin15.6.0 Apple LLVM version 7.3.0 (clang-703.0.31)
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 8
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = 8
			sizeof(wchar_t) = 4
			sizeof(void*) = 8
			sizeof(std::streamoff) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	8
		#define AH_SIZEOF_PTR	8
		#define AH_SIZEOF_LLONG 8
		#define AH_SIZEOF_SIZET 8
	#else
	//	#error "Unknown MacOSX platform!"
		#error "Unknown macOS platform!"
	#endif

#elif defined __MINGW64__ && defined __GNUC__
		#define AH_MINGW64
		// MINGW64, MinGW-w64
		#if defined __cplusplus && __cplusplus>=201103
				#define AH_HAVE_UNORDERED_SETMAP
		#endif
		#define AH_OS_BITS	64
		#define AH_MINGW64_X86_GCC_
		#define AH_RES_PLATFORM "MinGW-w64"

		#define AH_HAVE_16BIT_WCHAR_T	// sizeof(wchar_t) == 2
		#define AH_HAVE_WCHAR_H		// wchar.h L
		#define AH_HAVE_WCTYPE_H	// wctype.h L
		#define AH_HAVE_STDINT_H	// stdint.h L
		//#define AH_HAVE_BIG_ENDIAN	// Big Endian
		//#define AH_HAVE_UUIDAPI	// UUID֘AAPI
		//#define AH_HAVE_HASH_SETMAP	// stdex::hase_set/map
		#define AH_HAVE_UNORDERED_SETMAP	// std::unordered_set/map
		//#define AH_CASESENSE_FILENAME	// t@Cɑ啶ʂ
						// MinGW uses Windows file system
		//#define AH_NEED_SECURE_API	// strcpy_s() ̃ZLAAPIKv
		//#define AH_HAVE_VLA	// ϒz
					// ISO C++ forbids variable length array.
					// g++ -pedantic or g++ -Wvla
		#define AH_HAVE_STDRAND		// std::random L
		#define AH_HAVE_UNIQUE_PTR	// unique_ptr g
		#define AH_HAVE_CHAR16_T
		#define AH_OVER_CPP11 // C++11ȏ̋@\gBVS2015  __cplusplus mȒlłȂߗp
		/*	g++
			WindowsAlong4oCgBLP64ł͂ȂB
			sizeof(char) = 1
			sizeof(short) = 2
			sizeof(int) = 4
			sizeof(long) = 4
			sizeof(long long) = 8
			sizeof(float) = 4
			sizeof(double) = 8
			sizeof(long double) = 16
			sizeof(size_t) = 8
			sizeof(wchar_t) = 2
			sizeof(void*) = 8
			sizeof(std::streamoff) = 8
		*/
		#define AH_INT16	short
		#define AH_INT32	int
		#define AH_INT64	long long
		#define AH_UINT16	unsigned short
		#define AH_UINT32	unsigned int
		#define AH_UINT64	unsigned long long
		#define AH_LLONG	long long
		#define AH_SIZEOF_SHORT	2
		#define AH_SIZEOF_INT	4
		#define AH_SIZEOF_LONG	4
		#define AH_SIZEOF_PTR	8
		#define AH_SIZEOF_LLONG 8
		#define AH_SIZEOF_SIZET 8

#else
	#error "Unknown platform!"
#endif

#ifndef APSTUDIO_INVOKED
  #if 0 // DMCŖ肪ôł߂Ă 20070410 k16
	#ifdef AH_HAVE_STDINT_H
		#include <stdint.h>
		#undef AH_INT16
		#undef AH_INT32
		#undef AH_INT64
		#undef AH_UINT16
		#undef AH_UINT32
		#undef AH_UINT64
		#define AH_INT16	int16_t
		#define AH_INT32	int32_t
		#define AH_INT64	int64_t
		#define AH_UINT16	uint16_t
		#define AH_UINT32	uint32_t
		#define AH_UINT64	uint64_t
	#endif
  #endif
#endif


#if defined __cplusplus || defined __STDC__ || defined __STDC_VERSION__
	#ifndef AH_SIZEOF_SHORT
	#define AH_SIZEOF_SHORT	sizeof(short)
	#endif
	#ifndef AH_SIZEOF_INT
	#define AH_SIZEOF_INT sizeof(int)
	#endif
	#ifndef AH_SIZEOF_LONG
	#define AH_SIZEOF_LONG sizeof(long)
	#endif
	#ifndef AH_SIZEOF_PTR
	#define AH_SIZEOF_PTR sizeof(void*)
	#endif
	#ifndef AH_SIZEOF_LLONG
	#define AH_SIZEOF_LLONG sizeof(long long)
	#endif
	#ifndef AH_SIZEOF_SIZET
	 #if defined __cplusplus && __cplusplus>=201103L
	  #define AH_SIZEOF_SIZET sizeof(decltype(sizeof(int)))
	 #else
	  #define AH_SIZEOF_SIZET sizeof(size_t)
	 #endif
	#endif
#endif
#if defined __cplusplus && __cplusplus>=201103L
	static_assert(AH_SIZEOF_SHORT == sizeof(short),"AH_SIZEOF_SHORT is wrong value.");
	static_assert(AH_SIZEOF_INT   == sizeof(int),"AH_SIZEOF_INT is wrong value.");
	static_assert(AH_SIZEOF_LONG  == sizeof(long),"AH_SIZEOF_LONG is wrong value.");
	static_assert(AH_SIZEOF_PTR   == sizeof(void*),"AH_SIZEOF_PTR is wrong value.");
	static_assert(AH_SIZEOF_LLONG == sizeof(long long),"AH_SIZEOF_LLONG is wrong value.");
	static_assert(AH_SIZEOF_SIZET == sizeof(decltype(sizeof(int))),"AH_SIZEOF_SIZET is wrong value.");
#endif

#endif //!defined RC_INVOKED
#endif
